'use strict';

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var FunctionTree = require('function-tree').default;

module.exports = function () {
  var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  // TODO: Addd default context provider
  return function (task, payload) {
    // TODO: factory should only be called once! This requires refactor from https://github.com/cerebral/cerebral/issues/710
    var runTask = FunctionTree(options.providers);
    return new _promise2.default(function (resolve, reject) {
      var onEnd = function onEnd(execution, result) {
        runTask.off('error', onError);
        runTask.off('abort', onAbort);
        resolve(result);
      };
      var onAbort = function onAbort(execution, funcDetails, result) {
        runTask.off('error', onError);
        runTask.off('end', onEnd);
        resolve(result);
      };
      var onError = function onError(error, execution, payload) {
        runTask.off('end', onEnd);
        runTask.off('abort', onAbort);
        reject(error);
      };
      runTask.once('end', onEnd);
      runTask.once('abort', onAbort);
      runTask.once('error', onError);
      runTask(task, payload || {});
    });
  };
};

module.exports.sequence = require('function-tree').sequence;
module.exports.parallel = require('function-tree').parallel;