'use strict';

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

module.exports = function (test) {
  return function when(ctx) {
    var value = getValue(ctx, test);
    var path = getPath(ctx, value);

    if (typeof path !== 'function') {
      var paths = (0, _keys2.default)(ctx.path).join(', ');
      throw new Error('Could not find a matching path for value "' + value + '" in paths: ' + paths);
    }

    return path();
  };
};

function isTruthy(path) {
  return path.hasOwnProperty('true') || path.hasOwnProperty('false');
}

function getValue(ctx, resolver) {
  if (typeof resolver === 'function') {
    return resolver(ctx);
  }
  if ((typeof resolver === 'undefined' ? 'undefined' : (0, _typeof3.default)(resolver)) === 'object') {
    return resolver.getValue(ctx);
  }

  return resolver;
}

function getPath(ctx, value) {
  if (isTruthy(ctx.path)) {
    return value ? ctx.path.true : ctx.path.false;
  }
  if (ctx.path[value]) {
    return ctx.path[value];
  }

  return ctx.path.otherwise;
}